Package ghidra.trace.database.program

# Class DBTraceProgramViewMemorySpaceBlock

java.lang.Object
ghidra.trace.database.program.AbstractDBTraceProgramViewMemoryBlock
ghidra.trace.database.program.DBTraceProgramViewMemorySpaceBlock

All Implemented Interfaces:
  `MemoryBlock`, `Serializable`, `Comparable<MemoryBlock>`

public class DBTraceProgramViewMemorySpaceBlock extends AbstractDBTraceProgramViewMemoryBlock

See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class ghidra.trace.database.program.AbstractDBTraceProgramViewMemoryBlock

  `program`

  ### Fields inherited from interface ghidra.program.model.mem.MemoryBlock

  `ARTIFICIAL, EXECUTE, EXTERNAL_BLOCK_NAME, READ, VOLATILE, WRITE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBTraceProgramViewMemorySpaceBlock(DBTraceProgramView program, AddressSpace space)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected AddressSpace`
  `getAddressSpace()`
  `String`
  `getComment()`
  Get the comment associated with this block.
  `Address`
  `getEnd()`
  Return the end address of this block.
  `int`
  `getFlags()`
  Returns block flags (i.e., permissions and attributes) as a bit mask.
  `protected String`
  `getInfoDescription()`
  `String`
  `getName()`
  Get the name of this block
  `String`
  `getSourceName()`
  Get the name of the source of this memory block.
  `Address`
  `getStart()`
  Return the starting address for this block.
  `boolean`
  `isArtificial()`
  Returns the artificial attribute state of this block.
  `boolean`
  `isExecute()`
  Returns the value of the execute property associated with this block
  `boolean`
  `isRead()`
  Returns the value of the read property associated with this block
  `boolean`
  `isVolatile()`
  Returns the volatile attribute state of this block.
  `boolean`
  `isWrite()`
  Returns the value of the write property associated with this block
  `void`
  `setArtificial(boolean a)`
  Sets the artificial attribute state associated with this block.
  `void`
  `setComment(String comment)`
  Set the comment associated with this block.
  `void`
  `setExecute(boolean e)`
  Sets the execute property associated with this block.
  `void`
  `setName(String name)`
  Set the name for this block (See `NamingUtilities.isValidName(String)` for naming rules).
  `void`
  `setPermissions(boolean read, boolean write, boolean execute)`
  Sets the read, write, execute permissions on this block
  `void`
  `setRead(boolean r)`
  Sets the read property associated with this block.
  `void`
  `setSourceName(String sourceName)`
  Sets the name of the source file that provided the data.
  `void`
  `setVolatile(boolean v)`
  Sets the volatile attribute state associated of this block.
  `void`
  `setWrite(boolean w)`
  Sets the write property associated with this block.

  ### Methods inherited from class ghidra.trace.database.program.AbstractDBTraceProgramViewMemoryBlock

  `compareTo, contains, getAddressRange, getByte, getBytes, getBytes, getData, getMemorySpace, getSize, getSizeAsBigInteger, getSourceInfos, getType, isInitialized, isLoaded, isMapped, isOverlay, putByte, putBytes, putBytes`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface ghidra.program.model.mem.MemoryBlock

  `isExternalBlock`

- ## Constructor Details

  - ### DBTraceProgramViewMemorySpaceBlock

    public DBTraceProgramViewMemorySpaceBlock(DBTraceProgramView program, AddressSpace space)

- ## Method Details

  - ### getInfoDescription

    protected String getInfoDescription()
    Specified by:
      `getInfoDescription` in class `AbstractDBTraceProgramViewMemoryBlock`

  - ### getAddressSpace

    protected AddressSpace getAddressSpace()
    Overrides:
      `getAddressSpace` in class `AbstractDBTraceProgramViewMemoryBlock`

  - ### getStart

    public Address getStart()
    Description copied from interface: `MemoryBlock`
    Return the starting address for this block.
    Returns:
      block's start address

  - ### getEnd

    public Address getEnd()
    Description copied from interface: `MemoryBlock`
    Return the end address of this block.
    Returns:
      end address of the block

  - ### getFlags

    public int getFlags()
    Description copied from interface: `MemoryBlock`
    Returns block flags (i.e., permissions and attributes) as a bit mask. These bits defined as `MemoryBlock.READ`, `MemoryBlock.WRITE`, `MemoryBlock.EXECUTE`, `MemoryBlock.VOLATILE`, `MemoryBlock.ARTIFICIAL`.
    Returns:
      block flag bits

  - ### getName

    public String getName()
    Description copied from interface: `MemoryBlock`
    Get the name of this block
    Returns:
      block name

  - ### setName

    public void setName(String name) throws IllegalArgumentException, LockException
    Description copied from interface: `MemoryBlock`
    Set the name for this block (See `NamingUtilities.isValidName(String)` for naming rules). Specified name must not conflict with an address space name.
    Parameters:
      `name` - the new name for this block.
    Throws:
      `IllegalArgumentException` - if invalid name specified
      `LockException` - renaming an Overlay block without exclusive access

  - ### getComment

    public String getComment()
    Description copied from interface: `MemoryBlock`
    Get the comment associated with this block.
    Specified by:
      `getComment` in interface `MemoryBlock`
    Overrides:
      `getComment` in class `AbstractDBTraceProgramViewMemoryBlock`
    Returns:
      block comment string

  - ### setComment

    public void setComment(String comment)
    Description copied from interface: `MemoryBlock`
    Set the comment associated with this block.
    Specified by:
      `setComment` in interface `MemoryBlock`
    Overrides:
      `setComment` in class `AbstractDBTraceProgramViewMemoryBlock`
    Parameters:
      `comment` - the comment to associate with this block.

  - ### isRead

    public boolean isRead()
    Description copied from interface: `MemoryBlock`
    Returns the value of the read property associated with this block
    Returns:
      true if enabled else false

  - ### setRead

    public void setRead(boolean r)
    Description copied from interface: `MemoryBlock`
    Sets the read property associated with this block.
    Parameters:
      `r` - the value to set the read property to.

  - ### isWrite

    public boolean isWrite()
    Description copied from interface: `MemoryBlock`
    Returns the value of the write property associated with this block
    Returns:
      true if enabled else false

  - ### setWrite

    public void setWrite(boolean w)
    Description copied from interface: `MemoryBlock`
    Sets the write property associated with this block.
    Parameters:
      `w` - the value to set the write property to.

  - ### isExecute

    public boolean isExecute()
    Description copied from interface: `MemoryBlock`
    Returns the value of the execute property associated with this block
    Returns:
      true if enabled else false

  - ### setExecute

    public void setExecute(boolean e)
    Description copied from interface: `MemoryBlock`
    Sets the execute property associated with this block.
    Parameters:
      `e` - the value to set the execute property to.

  - ### setPermissions

    public void setPermissions(boolean read, boolean write, boolean execute)
    Description copied from interface: `MemoryBlock`
    Sets the read, write, execute permissions on this block
    Parameters:
      `read` - the read permission
      `write` - the write permission
      `execute` - the execute permission

  - ### isVolatile

    public boolean isVolatile()
    Description copied from interface: `MemoryBlock`
    Returns the volatile attribute state of this block. This attribute is generally associated with block of I/O regions of memory.
    Returns:
      true if enabled else false

  - ### setVolatile

    public void setVolatile(boolean v)
    Description copied from interface: `MemoryBlock`
    Sets the volatile attribute state associated of this block. This attribute is generally associated with block of I/O regions of memory.
    Parameters:
      `v` - the volatile attribute state.

  - ### isArtificial

    public boolean isArtificial()
    Description copied from interface: `MemoryBlock`
    Returns the artificial attribute state of this block. This attribute is generally associated with blocks which have been fabricated to facilitate analysis but do not exist in the same form within a running/loaded process state.
    Returns:
      true if enabled else false

  - ### setArtificial

    public void setArtificial(boolean a)
    Description copied from interface: `MemoryBlock`
    Sets the artificial attribute state associated with this block. This attribute is generally associated with blocks which have been fabricated to facilitate analysis but do not exist in the same form within a running/loaded process state.
    Parameters:
      `a` - the artificial attribute state.

  - ### getSourceName

    public String getSourceName()
    Description copied from interface: `MemoryBlock`
    Get the name of the source of this memory block.
    Specified by:
      `getSourceName` in interface `MemoryBlock`
    Overrides:
      `getSourceName` in class `AbstractDBTraceProgramViewMemoryBlock`
    Returns:
      source name

  - ### setSourceName

    public void setSourceName(String sourceName)
    Description copied from interface: `MemoryBlock`
    Sets the name of the source file that provided the data.
    Specified by:
      `setSourceName` in interface `MemoryBlock`
    Overrides:
      `setSourceName` in class `AbstractDBTraceProgramViewMemoryBlock`
    Parameters:
      `sourceName` - the name of the source file.